<?php
function writelog( $string ) {
	global $text, $currentuser, $currentuserdesc, $cms, $rootpath, $_SERVER, $time_offset, $gotlastpage;
	global $tree, $tngdomain, $subroot;

	// Set this variable to 1 if you wish to include the referrer info in the showlog data	
	// -------------------------------------
	$referrer_option = 1;
	
	require($subroot . "logconfig.php");

	// TNG just returns if there is a hacked link attempt, this code will simply defeat the attempt and still log the line
	$string = str_replace("http","ptth",$string);
	$string = str_replace("www","wwww",$string);

	if($exusers) {
		$users = explode(",", $exusers);
		if(in_array($currentuser,$users))
			return;
	}
	
// Revised IP retrieval and recording by Kees Lourens
   $remip = getenv( "REMOTE_ADDR" );
   if( !$remip ) $remip = $_SERVER['REMOTE_ADDR'];
   $remhost = getenv( "REMOTE_HOST" );
   if( !$remhost ) $remhost = $_SERVER['REMOTE_HOST'];
   if( !$remhost ) $remhost = @gethostbyaddr( $remip );
   if( !$remhost ) $remhost = $remip;
   if(isset($_SERVER['HTTP_X_FORWARDED_FOR'])) $remip2 = $_SERVER['HTTP_X_FORWARDED_FOR'];
   
// Revised IP retrieval and recording by Kees Lourens

   if( $badhosts && $remhost ) {
      $terms = explode(",", $badhosts);
      foreach( $terms as $term ) {
         if( $term ) {
            // next line modified Sep 24, 2006 to support IP filtering as well
            if( (strstr( $remhost, trim($term) )) || (strstr ($remip, trim($term))) || (strstr($currentuserdesc, trim($term))) )
               return;
         }
      }
   }

   if( $cms[support] && $currentuser )
      $string .= xmlcharacters(" $text[accessedby] $text[user]") . ": $currentuser";
   else {
      $string .= xmlcharacters(" $text[accessedby]") . " $remhost";
// Revised - Kees Lourens: two lines addition to add the external and internel remip to the string
      if ($remip != $remhost) $string .= xmlcharacters("/") . "$remip";
      if ($remip != $remip2) $string .= xmlcharacters("/") . "$remip2";
// Revised - Kees Lourens: if the host is unresolved the remip is already there and if there is an internal IP add it.
      if( $currentuser ) $string .= xmlcharacters(" ($text[user]: $currentuserdesc)");
   }

// ---------------------------------------------------
// Some of this will be dependent on your specific preferences
//
	if ($referrer_option == 1) {
		$referer = getenv('HTTP_REFERER'); 
		$referer = str_replace("&tree=$tree","",$referer);
		$referer = str_replace($tngdomain,".",$referer);
		$referer = str_replace("&&","&",$referer);
		$referer = str_replace("&amp;$","",$referer);
		$referer = ereg_replace("password=.*","",$referer);

		// It appends the referrer page info to the log line

  	if ($referer != '') { 
    	$string .= " from " . trim(strip_tags(htmlspecialchars($referer))); 
  	} 
  	if( strlen($string) > 400 ) $string = substr($string,0,400);
  }
// ----------------------------------------------------

// ----------------------------------------------------
// This section can be added to as more bots are noticed in the regular log
// The name of the alternate log is set as   botgenlog.txt
// Don't forget to ensure the permissions are set for full read/write access or you'll get a file
// access error when users access the page
//
// A link to the page to access this new log is on the regular log file display page
//
//
	if (strpos($remhost,"google") !== false || 
		strpos($remhost,"msnbot") !== false || 
		strpos($remhost,"inktomi") !== false || 
		strpos($remhost,"cuill.com") !== false || 
		strpos($remhost,"werelate") !== false || 
		strpos($remhost,"livebot") !== false || 
		strpos($remhost,"Panscient") !== false || 
		strpos($remip,"74.6.") !== false || 						// yahoos inktomi search engine
		strpos($remip,"72.30.") !== false || 						// yahoos inktomi search engine
		strpos($remip,"38.114.104") !== false ||					// Gigibot search engine
		strpos($remhost,"gigablast") !== false )
		{
			$thefile = "botgenlog.txt";
		} else {
			$thefile = $logfile;
		}

	$lines = file( $thefile );
	if( $maxloglines && sizeof( $lines ) >= $maxloglines ) {
		array_pop( $lines );
	}
	$updated = date ("D d M Y h:i:s A", time() + ( 3600 * $time_offset ) );
	array_unshift( $lines, "$updated $string.\n" );

	$fp = @fopen( $thefile, "w" );
	if( !$fp ) { die ( "Cannot open $thefile" ); }
// ------------------------------------------------------


	flock( $fp, LOCK_EX );
	$linecount = 0;
	foreach ( $lines as $line ) {
		trim( $line );
		if( $line )
			fwrite( $fp, $line );
		$linecount++;
		if( $linecount == $maxloglines ) break;
	}
	flock( $fp, LOCK_UN );
	fclose( $fp );
}

function preparebookmark($string) {
	global $gotlastpage;
	$_SESSION['tnglastpage'] = $string;
	$gotlastpage = true;
}
?>
